$:.push File.expand_path("../lib", __FILE__)

# Maintain your gem's version:
require "olympiamanagement/version"
insert_flag = 0
app_path = File.expand_path(__dir__)
template_path = ENV['PWD'] + '/app/templates'
all_template = Dir.glob(template_path+'/*/')
puts 'copying module'
all_template.each do |folder|
  if !folder.include?('mobile')
    if folder.split('/')[-1] != 'mobile'
      begin 
        system ('cp -r '+ app_path + '/modules/. ' + folder+'/modules/.')
        puts "finish copy module olympiamanagement to #{folder}"
      rescue 
        puts "error copy module olympiamanagement in #{folder}"
      end
    end
  end
end
# Describe your gem and declare its dependencies:
Gem::Specification.new do |s| 
  s.name = "olympiamanagement"
  s.version = Olympiamanagement::VERSION
  s.license     = "MIT"
  s.require_paths = ["lib"]
  s.authors = ["Ruling Digital"]
  s.date = "2019-12-09"
  s.description = "Olympia management for Orbit"
  s.email = ["orbit@rulingcom.com"]
  s.files = Dir["{app,config,db,lib}/**/*", "MIT-LICENSE", "Rakefile", "README.rdoc"]
  s.homepage = "http://www.rulingcom.com"
  s.licenses = ["MIT"]
  s.summary = "Olympia management for Orbit"
  s.test_files = Dir["test/**/*"]
end
